export type IntlNumberFormatOptions = Intl.NumberFormatOptions & {
  style?: IntNumberFormatOptionStyle & string;
  currency?: CurrencyCodes & string;
  currencyDisplay?: CurrencyDisplay & string;
};

//https://v8.dev/features/intl-numberformat

export type IntNumberFormatOptionStyle =
  /**
   * A decimal style format
   */
  | "decimal"
  /**
   * A percent style format.
   */
  | "percent"
  /**
   * A currency style format that uses the currency symbol defined by the number formatter locale.
   */
  | "currency"

  /**
   * A unit format
   */
  | "unit";

export type CurrencyDisplay = "none" | "symbol" | "code";
export type CurrencyCodes =
  | "AFA"
  | "ALL"
  | "DZD"
  | "AOR"
  | "ARS"
  | "AMD"
  | "AWG"
  | "AUD"
  | "AZN"
  | "BSD"
  | "BHD"
  | "BDT"
  | "BBD"
  | "BYN"
  | "BZD"
  | "BMD"
  | "BTN"
  | "BOB"
  | "BWP"
  | "BRL"
  | "GBP"
  | "BND"
  | "BGN"
  | "BIF"
  | "KHR"
  | "CAD"
  | "CVE"
  | "KYD"
  | "XOF"
  | "XAF"
  | "XPF"
  | "CLP"
  | "CNY"
  | "COP"
  | "KMF"
  | "CDF"
  | "CRC"
  | "HRK"
  | "CUP"
  | "CZK"
  | "DKK"
  | "DJF"
  | "DOP"
  | "XCD"
  | "EGP"
  | "SVC"
  | "ERN"
  | "EEK"
  | "ETB"
  | "EUR"
  | "FKP"
  | "FJD"
  | "GMD"
  | "GEL"
  | "GHS"
  | "GIP"
  | "XAU"
  | "XFO"
  | "GTQ"
  | "GNF"
  | "GYD"
  | "HTG"
  | "HNL"
  | "HKD"
  | "HUF"
  | "ISK"
  | "XDR"
  | "INR"
  | "IDR"
  | "IRR"
  | "IQD"
  | "ILS"
  | "JMD"
  | "JPY"
  | "JOD"
  | "KZT"
  | "KES"
  | "KWD"
  | "KGS"
  | "LAK"
  | "LVL"
  | "LBP"
  | "LSL"
  | "LRD"
  | "LYD"
  | "LTL"
  | "MOP"
  | "MKD"
  | "MGA"
  | "MWK"
  | "MYR"
  | "MVR"
  | "MRO"
  | "MUR"
  | "MXN"
  | "MDL"
  | "MNT"
  | "MAD"
  | "MZN"
  | "MMK"
  | "NAD"
  | "NPR"
  | "ANG"
  | "NZD"
  | "NIO"
  | "NGN"
  | "KPW"
  | "NOK"
  | "OMR"
  | "PKR"
  | "XPD"
  | "PAB"
  | "PGK"
  | "PYG"
  | "PEN"
  | "PHP"
  | "XPT"
  | "PLN"
  | "QAR"
  | "RON"
  | "RUB"
  | "RWF"
  | "SHP"
  | "WST"
  | "STD"
  | "SAR"
  | "RSD"
  | "SCR"
  | "SLL"
  | "XAG"
  | "SGD"
  | "SBD"
  | "SOS"
  | "ZAR"
  | "KRW"
  | "LKR"
  | "SDG"
  | "SRD"
  | "SZL"
  | "SEK"
  | "CHF"
  | "SYP"
  | "TWD"
  | "TJS"
  | "TZS"
  | "THB"
  | "TOP"
  | "TTD"
  | "TND"
  | "TRY"
  | "TMT"
  | "AED"
  | "UGX"
  | "XFU"
  | "UAH"
  | "UYU"
  | "USD"
  | "UZS"
  | "VUV"
  | "VEF"
  | "VND"
  | "YER"
  | "ZMK"
  | "ZWL";
